package mezz.jei.common.util;

import java.util.Locale;
import javax.annotation.Nullable;
import net.minecraft.class_1074;
import net.minecraft.class_1076;
import net.minecraft.class_1077;
import net.minecraft.class_310;

public final class Translator {
	@Nullable
	private static String cachedLocaleCode;
	@Nullable
	private static Locale cachedLocale;

	private Translator() {
	}

	public static String translateToLocal(String key) {
		return class_1074.method_4662(key);
	}

	public static String translateToLocalFormatted(String key, Object... format) {
		return class_1074.method_4662(key, format);
	}

	public static String toLowercaseWithLocale(String string) {
		return string.toLowerCase(getLocale());
	}

	@SuppressWarnings("ConstantConditions")
	private static Locale getLocale() {
		class_310 minecraft = class_310.method_1551();
		if (minecraft == null) {
			return Locale.getDefault();
		}
		class_1076 languageManager = minecraft.method_1526();
		class_1077 selected = languageManager.method_4669();
		return getLocale(selected);
	}

	private static Locale getLocale(class_1077 currentLanguage) {
		String code = currentLanguage.getCode();
		if (cachedLocale == null || !code.equals(cachedLocaleCode)) {
			cachedLocaleCode = code;
			String[] splitLangCode = code.split("_", 2);
			if (splitLangCode.length == 1) { // Vanilla has some languages without underscores
				cachedLocale = new Locale(code);
			} else {
				cachedLocale = new Locale(splitLangCode[0], splitLangCode[1]);
			}
		}
		return cachedLocale;
	}
}
