package mezz.jei.fabric.input;

import mezz.jei.common.input.keys.AbstractJeiKeyMappingBuilder;
import mezz.jei.common.input.keys.IJeiKeyMappingInternal;
import mezz.jei.common.input.keys.IJeiKeyMappingBuilder;
import mezz.jei.common.input.keys.JeiKeyConflictContext;
import mezz.jei.common.input.keys.JeiKeyModifier;
import net.minecraft.class_3675;

public class FabricJeiKeyMappingBuilder extends AbstractJeiKeyMappingBuilder {
    private final String category;
    private final String description;
    private JeiKeyConflictContext context = JeiKeyConflictContext.UNIVERSAL;
    private JeiKeyModifier modifier = JeiKeyModifier.NONE;

    public FabricJeiKeyMappingBuilder(String category, String description) {
        this.category = category;
        this.description = description;
    }

    @Override
    public IJeiKeyMappingBuilder setContext(JeiKeyConflictContext context) {
        this.context = context;
        return this;
    }

    @Override
    public IJeiKeyMappingBuilder setModifier(JeiKeyModifier modifier) {
        this.modifier = modifier;
        return this;
    }

    @Override
    protected IJeiKeyMappingInternal buildMouse(int mouseButton) {
        return new FabricJeiKeyMapping(
            category,
            description,
            context,
            modifier,
            class_3675.class_307.field_1672,
            mouseButton
        );
    }

    @Override
    public IJeiKeyMappingInternal buildKeyboardKey(int key) {
        return new FabricJeiKeyMapping(
            category,
            description,
            context,
            modifier,
            class_3675.class_307.field_1668,
            key
        );
    }
}
